package solms.xmlvend.messagevalidator;

/**
 * Implementers of this interface generate XMLVend Compliance reports by
 * accepting an object graph representing a ws-i log file, and outputting
 * a collection of object graphs representing Solms XMLVend reports. 
 *
 * @author dawidl
 * @version 0.1 (Jul 1, 2004)
 */
public interface ReportGenerator
{
    /** Generates a Collection of @link{solms.xmlvend.testreport.Testreport} instances,
     * based on a @link{org.wsi.log.LogType} (WS-I Monitor Log).
     * 
     * @throws Exception
     */
    public java.util.Collection generateReports(org.wsi.log.LogType wsiLog) throws Exception; 

}
