package solms.xmlvend.messagevalidator;

import solms.xmlvend.testreport.Testreport;

/**
 * Generates a String key for a report, given a ClientID and an ServerIpAddressAndPort.
 * This key must be a short, unique String which is safe for usage in a filename. 
 *
 * @author dawidl
 * @version 0.1 (Jul 2, 2004)
 */
public interface ReportKeyGenerator
{
    /** Generates a String key for the given server / client combination. This is used
     * e.g. as a key in a java.util.Map, as well as in file name(s).
     */
    public String generateKey(String clientID, String serverIPAndPort);
    
    
    /** Generates a String key for the given server / client combination. This is used
     * e.g. as a key in a java.util.Map, as well as in file name(s). Must be identical to
     * corresponding #generateKey(String,String).
     */
    public String generateKey(Testreport report);

}
