package solms.xmlvend.messagevalidator;

import java.util.SortedMap;

/**
 * A ReportSplitter is responsible for taking a reference to a WS-I Log (Object)
 * and a SortedMap of associated HttpMessageEntry request and response objects, and producing
 * a Collection of TestReport objects.
 *
 * @author dawidl
 * @version 0.1 (Jul 1, 2004)
 */
public interface ReportSplitter
{
    /** Produces a Collection of TestReports. These are "raw" reports, and no
     * testing / validation should be done whatsoever. It is. however, responsible
     * for calculating time spans, etc.
     * @param messages A SortedMap which has HTTPMessageEntry instances for both keys (requests)
     *  and values (responses)
     * @return A SortedMap of @link{solms.xmlvend.testreport.TestReport} instances.
     * @throws Exception
     */
    public SortedMap produceRawReports(SortedMap messages) throws Exception;
}
