package solms.xmlvend.messagevalidator;

/**
 * Exception to indicate a problem a ReportValidator encountered during
 * it's processing of a report. This should *not* be used to indicate a report's
 * non-passing of validation (which is indicated by attaching Error elements to the
 * offending messages), but rather to indicate I/O or infrastructure failures. 
 *
 * @author dawidl
 * @version 0.1 (Jul 4, 2004)
 */
public class ReportValidationException extends Exception
{
    /* Note, there is no no-argument (default) constructor */

	/** Specifies a  failure message */
    public ReportValidationException(String msg)
    {
        super(msg);
    }
    
    /** Specifies a message and a root cause */
    public ReportValidationException(String msg, Throwable rootCause)
    {
        super(msg, rootCause);
    }

    private static final long serialVersionUID = -1854274251012261381L;
}
