package solms.xmlvend.messagevalidator.impl;

import javax.xml.bind.ValidationEvent;
import javax.xml.bind.ValidationEventHandler;

/**
 * This handler is used when JAXB unmarshals a WS-I log file to
 * an object graph. We use it simply to "ignore" all errors, as we don't care about the 
 * validity of that file - we just want the messages contained within.
 *
 * @author dawidl
 * @version 0.1 (Jun 30, 2004)
 */
public class LogUnmarshalValidationHandler implements ValidationEventHandler
{

    /**
     * @return Always returns true (continue processing as far as possible)
     */
    public boolean handleEvent(ValidationEvent evt)
    {
        // Ignore errors
        return true;
    }

}
