package solms.xmlvend.messagevalidator.impl;

import solms.xmlvend.messagevalidator.ReportKeyGenerator;
import solms.xmlvend.testreport.Testreport;

/**
 * Generates a short key.
 *
 * @author dawidl
 * @version 0.1 (Jul 2, 2004)
 */
public class ReportKeyGeneratorImpl implements ReportKeyGenerator
{

    /* (non-Javadoc)
     * @see solms.xmlvend.messagevalidator.ReportKeyGenerator#generateKey(java.lang.String, java.lang.String)
     */
    public String generateKey(String clientID, String serverIPAndPort)
    {
        if (clientID == null)
            clientID = "unknown";
        if (serverIPAndPort == null)
        {
            serverIPAndPort = "unknown";
        }
        else
        {
            // Wrap port in brackets (this can be done better :-)
            if (serverIPAndPort.indexOf(":") != -1)
            {
                serverIPAndPort = serverIPAndPort.replaceAll(":","(") + ")";
            }
        }
        
        return clientID + "--" + serverIPAndPort;
    }

    /* (non-Javadoc)
     * @see solms.xmlvend.messagevalidator.ReportKeyGenerator#generateKey(solms.xmlvend.testreport.Testreport)
     */
    public String generateKey(Testreport report)
    {
        try
        {
            return generateKey(report.getClient().getClientId(), report.getServer().getIpAddess());
        } catch (Exception e)
        {
            return generateKey(null,null);
        }
    }

}
