package solms.xmlvend.messagevalidator.util;

import java.util.Comparator;

import org.wsi.log.MessageEntry;

/**
 * Orders MessageEntry instances by date.
 *
 * @author dawidl
 * @version 0.1 (Jul 1, 2004)
 */
public class MessageEntryDateComparator implements Comparator
{
    /** Default constructor
     */
    public MessageEntryDateComparator()
    {
        comp = new CalendarComparator();
    }
    

    /* (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    public int compare(Object arg0, Object arg1)
    {
        try
        {
            MessageEntry m1 = (MessageEntry)arg0;
            MessageEntry m2 = (MessageEntry)arg1;
            if (m1 == null || m2 == null || m1 == m2)
                return 0;
            // Compare dates
            return comp.compare(m1.getTimestamp(), m2.getTimestamp());
        }
        catch (Exception e)
        {
            return 0;
        }
    }
    
    // Uses this comparator under the hood
    CalendarComparator comp;

}
