package solms.xmlvend.messagevalidator.util;

import org.wsi.log.HttpMessageEntry;

import solms.xmlvend.testreport.Testreport;

/**
 * Utility class to assist with displaying some things which we can't do with
 * a toString() because the classes are generated.
 *
 * @author dawidl
 * @version 0.1 (Jul 1, 2004)
 */
public class QuickDisplay
{

    public static String toSmallString(HttpMessageEntry msg)
    {
        if (msg == null)
            return "[No HTTP Message]";
        return msg.getTimestamp().getTime() + " (CID: "+msg.getConversationID()+") (ID: "+msg.getID()+")";
    }
    
    public static String toSmallString(Testreport report)
    {
        try
        {
            return report.getClient().getClientId() + " -> " + report.getServer().getIpAddess() + " ("+report.getServiceRequest().size()+" service request(s))";
        } catch (Exception e)
        {
            return "["+e.getClass().getName()+"]";
        }
    }
}
