/*
 * Created on Jul 22, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package solms.xmlvend.messagevalidator.validators;

import java.util.ArrayList;
import java.util.Collection;

import org.xml.sax.SAXException;

/**
 * This specialised SAXException represents multiple exceptions, i.e. multiple
 * parsing errors encountered, but thrown only as one composite object.
 *
 * @author dawidl
 * @version 0.1 (Jul 22, 2004)
 */
public class MultiSAXException extends SAXException
{
    private Collection exceptions;
    private String mainMessage;
    private static final long serialVersionUID = -1854274251012261382L;

    /** Default constructor (with message)
     * @param arg0
     */
    public MultiSAXException(String msg)
    {
        super(msg);
        exceptions = new ArrayList();
        mainMessage = msg;
    }
    
    public MultiSAXException()
    {
        this(null);
    }
    
    
    /** Adds an exception to the collection of internal exceptions
     * 
     * @param e
     */
    public void addException(SAXException e)
    {
        if (e == null) return;
        exceptions.add(e);
    }
    
    
    /** Returns a collection of SAXException instances contained
     * in this composite exception. Never null.
     * 
     * @return
     */
    public Collection getExceptions()
    {
        return exceptions;
    }
    
    
    /** Customised message
     * @see org.xml.sax.SAXException#getMessage()
     */
    public String getMessage()
    {
        return (mainMessage != null ? mainMessage : "Multiple Parsing Errors") + " (" + exceptions.size() + " exceptions)";
    }    
}
